function Create(self)
	self.switchTimer = Timer();
	self.parentgun = nil;
	self.parentactor = nil;
	self.canswitch = true;
	self.canturnoff = true;

-------------------------
-----

	self.mainweaponname = "M16 Alt Fire";
	self.mainweaponclass = "HDFirearm";
	self.altweaponname = "M16";
	self.altweaponclass = "HDFirearm";
	self.altweaponmodule = "SpecOps.rte";

-----
-------------------------

   local curdist = 20;
   for i = 1,MovableMan:GetMOIDCount()-1 do
   	target = MovableMan:GetMOFromID(i);
   	if target.PresetName == self.mainweaponname then
         local avgx = target.Pos.X - self.Pos.X;
         local avgy = target.Pos.Y - self.Pos.Y;
         local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
	if dist < curdist then
	self.parentgun = target;
	end
    end
end

   if self.parentgun == nil then
	self.ToDelete = true;
	self.LifeTime = 0;
	self.canturnoff = false;
	end
end

function Update(self)
	self.ToDelete = false;
	self.ToSettle = false;

   if self.canturnoff == true then
    if self.parentgun.ID ~= 255 then
	self.Vel = Vector(0,0);
	self.Pos = self.parentgun.Pos;
	end
end

   if self.canturnoff == true then
    if self.parentgun.ID == 255 then
	self.parentactor = nil;
	self.ToDelete = true;
	self.LifeTime = 0;
	end
end

   if not(MovableMan:IsActor(self.parentactor)) and self.canswitch == true then
   local curdist = 50;
   for actor in MovableMan.Actors do
      local avgx = actor.Pos.X - self.Pos.X;
      local avgy = actor.Pos.Y - self.Pos.Y;
      local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
      if dist < curdist and actor:HasObject(self.mainweaponname) then
	self.parentactor = actor;
	end
    end
end

   if MovableMan:IsActor(self.parentactor) and self.canturnoff == true then
    if not(self.parentactor:HasObject(self.mainweaponname)) then
	self.parentactor = nil;
	end
end
   if MovableMan:IsActor(self.parentactor) and self.parentgun ~= nil and self.parentgun.ID ~= 255 and UInputMan:KeyPressed(26) or UInputMan:KeyPressed(37)or UInputMan:KeyPressed(37) and self.canswitch == true then
   for i = 1,MovableMan:GetMOIDCount()-1 do
   	gun = MovableMan:GetMOFromID(i);
   	if gun.PresetName == self.mainweaponname and gun.RootID == self.parentactor.ID then
	self.canswitch = false;
	self.canturnoff = false;
	self.parentactor.AIMode = Actor.AIMODE_SENTRY;
	self.parentgun.ToDelete = true;
	self.parentgun.LifeTime = 0;
     if self.altweaponclass == "HDFirearm" then
	local switchgun = self.parentactor:AddInventoryItem(CreateHDFirearm(self.altweaponname,self.altweaponmodule));
     elseif self.altweaponclass == "TDExplosive" then
	local switchgun = self.parentactor:AddInventoryItem(CreateTDExplosive(self.altweaponname,self.altweaponmodule));
     elseif self.altweaponclass == "HeldDevice" then
	local switchgun = self.parentactor:AddInventoryItem(CreateHeldDevice(self.altweaponname,self.altweaponmodule));
	end
	self.switchTimer:Reset();
	end
    end
end

   if self.canswitch == false and self.switchTimer:IsPastSimMS(10) then
	self.parentactor:GetController():SetState(Controller.WEAPON_CHANGE_PREV,true);
	self.ToDelete = true;
	self.LifeTime = 0;
	end

end